<template>
  <v-app>
    <v-navigation-drawer
      v-model="drawer"
      :mini-variant="miniVariant"
      :clipped="clipped"
      fixed
      app
    >
      <v-list>
        <v-list-item-group v-model="selectedMenu">
          <v-list-item
            v-for="(item, i) in items"
            :key="i"
            :to="item.to"
            router
            exact
            @click="saveRoute(item.to)"
          >
            <v-list-item-action>
              <v-icon>{{ item.icon }}</v-icon>
            </v-list-item-action>
            <v-list-item-content>
              <v-list-item-title v-text="item.title" />
            </v-list-item-content>
          </v-list-item>
        </v-list-item-group>
      </v-list>
    </v-navigation-drawer>
    <v-app-bar :clipped-left="clipped" fixed app>
      <v-app-bar-nav-icon @click.stop="drawer = !drawer" />
      <v-btn icon @click.stop="miniVariant = !miniVariant">
        <v-icon>mdi-{{ `chevron-${miniVariant ? 'right' : 'left'}` }}</v-icon>
      </v-btn>
      <v-toolbar-title v-text="title" />
      <v-spacer />
      <v-btn icon @click.stop="rightDrawer = !rightDrawer">
        <v-icon>mdi-account</v-icon>
      </v-btn>
    </v-app-bar>
    <v-main>
      <v-container fluid>
        <nuxt-child />
      </v-container>
    </v-main>
    <v-navigation-drawer v-model="rightDrawer" :right="right" temporary fixed>
      <v-list>
        <v-list-item-group>
          <v-list-item @click="logOut">
            <v-list-item-icon>
              <v-icon light>mdi-logout</v-icon>
            </v-list-item-icon>
            <v-list-item-content>
              <v-list-item-title>Cerrar Sesión</v-list-item-title>
            </v-list-item-content>
          </v-list-item>
        </v-list-item-group>
      </v-list>
    </v-navigation-drawer>
    <v-footer :absolute="!fixed" app>
      <span>&copy; {{ new Date().getFullYear() }}</span>
    </v-footer>
  </v-app>
</template>

<script lang="ts">
import UserStore from '../../store/user'
import { Vue, Component, getModule } from 'nuxt-property-decorator'
@Component({
  name: 'inicio',
})
export default class inicio extends Vue {
  clipped: boolean = true
  drawer: boolean = true
  fixed: boolean = true
  items: Array<any> = []
  miniVariant: boolean = false
  right: boolean = true
  rightDrawer: boolean = false
  title: string = 'BOXSENDI'

  selectedMenu = 0

  logOut() {
    this.$auth.logout()
    this.$router.push('/login')
    this.$auth.$storage.removeUniversal('userId')
    this.$auth.$storage.removeUniversal('menu')
  }

  saveRoute(route: any) {
    this.$auth.$storage.setUniversal('route', route)
  }

  created() {
    const menu: any = this.$auth.$storage.getUniversal('menu')
    this.items = Object.assign({}, menu)
    const id = this.$auth.$storage.getUniversal('userId')
    if (process.client) {
      const user = getModule(UserStore, this.$store)
      user
        .getUSer(id)
        .then((res) => {
          this.$auth.setUser(res)
        })
        .catch((error) => {
          console.error('Ocurrio un error:', error)
        })
    }
  }
}
</script>